summaryrefslogtreecommitdiffstats
path: root/scripts
diff options
context:
space:
mode:
Diffstat (limited to 'scripts')
-rw-r--r--scripts/makepkg.sh.in29
1 files changed, 20 insertions, 9 deletions
diff --git a/scripts/makepkg.sh.in b/scripts/makepkg.sh.in
index 4a68c844..4399076b 100644
--- a/scripts/makepkg.sh.in
+++ b/scripts/makepkg.sh.in
@@ -899,18 +899,29 @@ create_xdelta() {
if [ "$base_file" != "" ]; then
msg "$(gettext "Making delta from version %s...")" "$latest_version"
local delta_file="$PKGDEST/$pkgname-${latest_version}_to_$pkgver-$pkgrel-$CARCH.delta"
+ local ret=0
# xdelta will decompress base_file & pkg_file into TMP_DIR (or /tmp if
# TMP_DIR is unset) then perform the delta on the resulting tars
- xdelta delta "$base_file" "$pkg_file" "$delta_file"
-
- # Generate the final gz using xdelta for compression. xdelta will be our
- # common denominator compression utility between the packager and the users
- # makepkg and pacman must use the same compression algorithm or the delta
- # generated package may not match, producing md5 checksum errors.
- msg2 "$(gettext "Recreating package tarball from delta to match md5 signatures")"
- msg2 "$(gettext "NOTE: the delta should ONLY be distributed with this tarball")"
- xdelta patch "$delta_file" "$base_file" "$pkg_file"
+ xdelta delta "$base_file" "$pkg_file" "$delta_file" || ret=$?
+
+ if [ $ret -eq 0 -o $ret -eq 1 ]; then
+ # Generate the final gz using xdelta for compression. xdelta will be our
+ # common denominator compression utility between the packager and the
+ # users. makepkg and pacman must use the same compression algorithm or
+ # the delta generated package may not match, producing md5 checksum
+ # errors.
+ msg2 "$(gettext "Recreating package tarball from delta to match md5 signatures")"
+ msg2 "$(gettext "NOTE: the delta should ONLY be distributed with this tarball")"
+ ret=0
+ xdelta patch "$delta_file" "$base_file" "$pkg_file" || ret=$?
+ if [ $ret -ne 0 ]; then
+ error "$(gettext "Could not generate the package from the delta.")"
+ exit 1
+ fi
+ else
+ warning "$(gettext "Delta was not able to be created.")"
+ fi
else
warning "$(gettext "No previous version found, skipping xdelta.")"
fi